<template>
  <q-select
    outlined
    v-model="selectModel"
    use-input
    input-debounce="200"
    :label="label"
    :options="options"
    @filter="filter"
  >
    <template v-slot:no-option>
      <q-item>
        <q-item-section class="text-grey">Không có kết quả</q-item-section>
      </q-item>
    </template>
    <template v-if="$scopedSlots.option" v-slot:option="scope">
      <slot name="option" :data="scope" />
    </template>
  </q-select>
</template>

<script>
export default {
  props: {
    label: { type: String, default: '' },
    value: { type: Object, default: null },
    options: { type: Array, default: () => [] }
  },
  computed: {
    selectModel: {
      get() {
        return this.value;
      },
      set(v) {
        this.$emit('input', v);
      }
    }
  },
  methods: {
    filter(val, update) {
      this.$emit('filter', { filter: val });
      update();
    }
  }
};
</script>
